  @echo off
setlocal enabledelayedexpansion enableextensions

rem
rem call "C:\CAMS\7za.exe" a -r -tzip "c:\CAMS\Submitted\2012_04_20_213.zip" "c:\CAMS\Submitted\2012_04_20_213\213\*.*"


	echo.=============================================================
	echo.%date% %time% - %~dpnx0 [%*]
:CHECKHELP
	set bat_vers=1.0

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

		
	
	
:SETUP
	set return=goto :EOF
	set bat_return=goto :EOF
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	set BAT_ECHO=call :ECHOONLY

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	set bat_exedrive=!bat_exedir:~0,2!&			rem f:
	
	set bat_logfile=!bat_exedir!\Logs\7zip.bat.log

	
	%bat_echolog% =============================================================
	%bat_echolog% %date% %time% - %~dpnx0 %*
	
	set bat_returncode=0

set bat_
	call :PARSEARGS %*
set bat_
goto :MAIN

	
:PARSEARGS
!bat_echolog! call :PARSEARGS %*
	set bat_recurse=
	set bat_options=
:PARSEARGS2
!bat_echolog! '     :PARSEARGS %1, %~dp1, %~nx1

	if "%~1" equ "" goto :PARSEARGES_END	
	set bat_parseargs_temp=%1
	if /i "!bat_parseargs_temp!" equ "-password" (
		echo.  set bat_options=%bat_options% -p%2
		       set bat_options=%bat_options% -p%2
		shift
		shift
set bat_options
pause
		goto :PARSEARGS2
	)


	echo.%~1|find /i "-r">nul:
	if %errorlevel% equ 0 (
		       set bat_recurse=-r
		echo.  set bat_recurse=-r
		shift
set bat_recurse
pause
		goto :PARSEARGS2
	)

	set bat_password=


	set bat_dest=%~1
	set bat_src=%~2
	shift
	shift


:PARSEARGS_END
	set bat_parseargs_temp=
!bat_echolog! return-:PARSEARGS [recurse=%bat_recurse%, zip=!bat_dest!, src=!bat_src!, bat_options=%bat_options%]
%return%



REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================

:MAIN
set bat_

	echo ....call "!bat_exedir!\7za.exe" a !bat_recurse! !bat_options! -tzip "!bat_dest!" "!bat_src!"
	         call "!bat_exedir!\7za.exe" a !bat_recurse! !bat_options! -tzip "!bat_dest!" "!bat_src!"

goto :DONE






:CLEARSCREEN
	for /l %%A in (1,1,50) do (echo.)
%bat_return%



:GETFILECOUNT [out] bat_capturedcount [in] "dir"
!bat_echolog! call :GETFILECOUNT "%~1"  "%~2"
	set %~1=0
	for /f "usebackq tokens=*" %%a in (`dir "%~2" /b /a-d^|find /i /c ".bin"`) do (
		title set %1=%%a
		      set %1=%%a
	)
!bat_echolog! return-:GETFILECOUNT [%~1=!%1!]
%bat_return%



:FORMATDATE [out] bat_dateinput [in] bat_captureddate
	set bat_temp=%2
	set %1=!bat_temp:~5,2!/!bat_temp:~-2!/!bat_temp:~0,4!
%bat_return%





:SEARCHFORDIR [out] bat_retval [out] bat_retval2[in]  [out] bat_retval3 bat_basedir
	rem bat_retval	is a fully qualified directory name
	rem bat_retval2 is that path not including the last directory name of the path
	rem bat_retval3 is the last directory name in the path
	
	echo :SEARCHFORDIR "%~1" 
	set bat_retval= 
	for /f "usebackq tokens=*" %%a in (`dir "%~1" /s/b /ad`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					set bat_retval=%%a
					set bat_retval2=%%~dpa::
					set bat_retval2=!bat_retval2:\::=!
					set bat_retval2=!bat_retval2:::=!
					set bat_retval3=%%~nxa
				)
			)
		)
	)

echo return-:SEARCHFORDIR: bat_retval=!bat_retval!, bat_retval2=!bat_retval2!, bat_retval3=!bat_retval3!
%bat_return%




:SEVENZIP
!bat_echolog! call :SEVENZIP
	set bat_retval=0
	!bat_echolog! call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_tempsrc!\*.*"
	              call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_tempsrc!\*.*"
	              set bat_retval=!errorlevel!
	              if !bat_retval! neq 0 (
	              	set bat_recent_error_msg=16.ERROR - Failed to create the zip file...
	              	!bat_echolog! '    !bat_recent_error_msg!
	              	!bat_echolog! '    call "!bat_exedir!\7za.exe" a -r -tzip "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip" "!bat_tempsrc!\*.*" 
	              	!bat_echolog! '    errorlevel=!bat_retval!
	              ) else (
	              	set bat_recent_error_msg=16.SUCCESS - created "!bat_targetlocation!\CAMS\Submitted\!bat_tempdir!!bat_tempcounter!.zip"
	              	!bat_echolog! '    !bat_recent_error_msg!
	              )
:SEVENZIP_END
!bat_echolog! return-:SEVENZIP [errorlevel=!bat_retval! !bat_recent_error_msg!]
%bat_return%





	rem 1u. Command Prompt *****************************************
:CMDPROMPT
	cd /d !bat_targetlocation!
	echo start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	     start "CAMS prompt" /d "!bat_exedir!" /i "!windir!\system32\cmd.exe"
	cd /d !bat_exedir!

%bat_return%




	rem u4. CheckFreeSpace *****************************************
:CHECKFREESPACE
	set bat_choice=
	set /P bat_choice=Enter drive [!bat_targetlocation:~0,2!]: 
	if /i "!bat_choice!" equ "" (set bat_choice=!bat_targetdrive:~0,2!)
	set bat_choice=!bat_choice::=!
	set bat_choice=!bat_choice!:

	echo call CheckFreeSpace.bat !bat_choice!
	call CheckFreeSpace.bat !bat_choice!
	pause
%bat_return%



	rem u5. ListDrives *********************************************
:LISTDRIVES
	echo call ListDrives.bat
	call ListDrives.bat
	pause
%bat_return%




:VARIABLES
	set bat_
	pause
%return%



	rem Echo to the console and to the bat_logfile
:ECHOLOG
	set bat_echolog_temp=
	set bat_echolog_temp=%*

	if not defined bat_echolog_temp (
		echo.
		!bat_log!
		goto :ECHOLOG_END
	)
	set bat_echolog_temp=!bat_echolog_temp:~0,3000!
	echo.!bat_pushstring!!bat_echolog_temp!
	!bat_log! %*

:ECHOLOG_END
exit /b 0




:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%


:ECHOONLY
	rem Echo to the console
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.
		%bat_return%
	)

	set bat_echolog_temp=%*

	echo %bat_echolog_temp%
%bat_return%








rem call "C:\CAMS\7za.exe" a -r -tzip "c:\CAMS\Submitted\2012_04_20_213.zip" "c:\CAMS\Submitted\2012_04_20_213\213\*.*"


:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 [-r] [-password ^<pwd^>] "target zip file" "source file spec"
	echo.
	echo.The target zip file and the source filespec must be the last two command line arguments
	echo.
	echo Uses 7za.exe command line utility to zip the specified files.
	echo.
	echo The optional -r command line option causes it to recurse subdirectories. 
	echo.
	echo.
	echo Example:
	echo        %~nx0 "test.zip" "test*.*"
	echo.
exit /b -99



:DONE
	echo Done with %0 %*
	echo.
