 @echo off
	setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)
	goto :SETUP %*

:CHECKHELP_END

	Flowchart:

	New changes 09/21/2011:
		
	
:SETUP

:START

    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	
	set bat_CD_flag=%~1
	set bat_camera=%~2
	set bat_duration=%~3
	set bat_targetlocation=%~4
	set bat_savetargetlocation=%~4


:CURDATETIME

	call :GETCAPTUREDIR %*
	call :GETARCHIVEDDIR %*
	call :GETDETECTFILE %*
	call :WAITCAPTUREDETECT %*
	call :COPYARCHIVED %*

	call :POSTCAPTURE %*
	if /i "!bat_retval!" neq "success" (goto :DONE)

	rem call :MULTISCAN
	rem call :WAITFORMULTISCAN
	rem call :POSTMULTISCAN
	rem call :CAMSMENU
goto :DONE



:GETCAPTUREDIR
	rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	rem created.  It uses the Year, Month, and Day (YYYY_MM_DD) to do a matching directory
	rem search. The last one in the list should be the most recent FTP_CaptureAndDetect directory.

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%

	rem This for loop will complete with the newest directory with the specified date
	rem as the prefix.  Even if there are multiple directories with the same date, the 
	rem newest one be contained in resulting value of ftp_captureddir.

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  Careful, there is a chance that it didn't 
	rem create a directory and you'd be choosing the wrong dir.

	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					 set bat_targetsearchdir=%%~a

					rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					 set bat_captureddir=%%~a

					rem example: bat_captureddirname=2012_01_18_01_00_13
					 set bat_captureddirname=%%~nxa

					rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)

	echo bat_targetsearchdir=!bat_targetsearchdir!>>"!bat_logfile!"
	echo bat_captureddir=!bat_captureddir!>>"!bat_logfile!"
	echo bat_captureddirname=!bat_captureddirname!
	
	rem Example: bat_captureddate=2012_01_18
	set bat_captureddate=!bat_captureddirname:~0,10!
	
	set bat_cap
%bat_return%


:GETARCHIVEDDIR
		rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
		rem created for ArchivedFiles.  It uses the Year, Month, and Day (YYYY_MM_DD) to do a 
		rem matching directory search. The last one in the list should be the most recent 
		rem FTP_CaptureAndDetect directory.
	
		set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
	
		rem This for loop will complete with the newest directory with the specified date
		rem as the prefix.  Even if there are multiple directories with the same date, the 
		rem newest one be contained in resulting value of ftp_captureddir.
	
		set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	
		rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
		rem ordered ascending by date. The last one will be the one created by the 
		rem FTP_CaptureAndDetect.exe program.  CAREFUL, there is a chance that
		rem there is no matching ArchivedFiles dir. 
		
		set bat_targetsearchdir=
		set bat_archiveddir=
		set bat_archiveddirname=
		set bat_archivedbasedir=
		set bat_archiveddate=
		echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b^|find /i "!bat_captureddate!"`^) do...>>!bat_logfile!"
		for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b^|find /i "!bat_captureddate!"`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
						rem Example: bat_targetsearchdir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
						set bat_targetsearchdir=%%~a

						rem Example: bat_captureddir=C:\CAMS\CapturedArchivedFiles\2012_01_18_01_00_13
						set bat_archiveddir=%%~a

						rem example: bat_archiveddirname=2012_01_18_01_00_13
						set bat_archiveddirname=%%~nxa

						rem example: bat_archivedbasedir=C:\CAMS\ArchivedFiles
						set bat_archivedbasedir=%%~dpa::
						set bat_archivedbasedir=!bat_archivedbasedir:\::=!
						set bat_archivedbasedir=!bat_archivedbasedir:::=!
					)
				)
			)
		)

		echo bat_targetsearchdir=!bat_targetsearchdir!>>"!bat_logfile!"
		echo bat_archiveddir=!bat_archiveddir!>>"!bat_logfile!"
		echo set bat_archiveddirname=!bat_archiveddirname!
		
		rem Example: bat_archiveddate=2012_01_18
		set bat_archiveddate=!bat_archiveddirname:~0,10!

	set bat_archived
%bat_return%


:GETDETECTFILE
	call "!bat_exedir!\GetDetectFile.bat" "bat_detectfile" "!bat_archivedFilesdir!"
%bat_return%


:WAITCAPTUREDETECT
echo :WAITCAPTUREDETECT %*
	echo     WaitForFile rw "!bat_detectfile!"
	         WaitForFile rw "!bat_detectfile!"
	echo.
	echo     "!bat_detectfile!" is ready to use...
	echo.
%bat_return%


:COPYARCHIVED
echo :COPYARCHIVED
	echo     copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	         copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"

	echo     move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"
	         move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"

	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo.txt
	set bat_detectfile3=FTPdetectinfo
	set bat_detectfile4=FTPdetectinfo.txt
%bat_return%


:POSTCAPTURE
echo :POSTCAPTURE %*
	set bat_retval=success
	rem set bat_detectfile=!bat_captureddir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_detectfile!" (
		echo.>>"!bat_logfile!"
		echo.
		echo ERROR - "!bat_detectfile!" not found...>>"!bat_logfile!"
		echo ERROR - "!bat_detectfile!" not found...
		echo.>>"!bat_logfile!"
		echo.
		dir "!bat_captureddir!\ftpdetect*.*" /s/b /a-d /od>>"!bat_logfile!"
		dir "!bat_captureddir!\ftpdetect*.*" /s/b /a-d /od
		set bat_retval=postcapture failed
		%bat_return%
	)


	set bat_capturedcount=0
	if exist "!bat_captureddir!\*.bin" (
		for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`) do (
			set /a bat_capturedcount=%%~b
		)
	)
	echo     !bat_captureddir!    [Files=!bat_capturedcount!]
	echo.


	call :READCONFIG
	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!

	call :SAVECONFIG
%bat_return%



:MULTISCAN
echo :MULTISCAN
rem set bat_targetsearchspec=!bat_targetsearchspec!\2011_12_22_01_31_3?
set bat_targetsearchspec
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo bat_targetsearchdir=%%~a>>"!bat_logfile!"
					 set bat_targetsearchdir=%%~a

					echo bat_captureddir=%%~a>>"!bat_logfile!"
					 set bat_captureddir=%%~a
					 set bat_captureddate=%%~nxa
					 set bat_captureddate=!bat_captureddate:~0,10!

					set bat_targetcount=0
					if exist "%%~a\*.bin" (
						for /f "usebackq tokens=*" %%b in (`dir "%%~a" /a-d /s/b^|find /i /c ".bin"`) do (
							set /a bat_targetcount=%%~b
						)
					)
					echo     !bat_captureddir!    [Files=!bat_targetcount!]
				)
			)
		)
	)
	echo.
	
	call :READCONFIG
	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!
	call :SAVECONFIG

:MAKERERUNFILE
	echo.>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo @echo off>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo setlocal enableextensions enabledelayedexpansion>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	for /f "usebackq tokens=*" %%a in (`set`) do (
		echo set %%~a>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	)
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!">>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!">>"!bat_logfile!"
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!"
	     call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!"

	
%bat_return%



:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo :WAITFORMULTISCAN Waiting 60 seconds for makeCaseListing.bat to finish
	!bat_WAIT!  60

	set bat_archivedsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_captureddate!*.*
set bat_archivedsearchspec
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_archivedsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo bat_archiveddir=%%~a>>"!bat_logfile!"
					set bat_archiveddir=%%~a
					set bat_archivedfilesdir=%%~a
				)
			)
		)
	)

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`) do (
		echo call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
		echo.
		echo     FINISHED with: "%%a"
	)

:MERGE
	echo call "!bat_exedir!\MergeClassFiles.bat" "!bat_archiveddir!"
	     call "!bat_exedir!\MergeClassFiles.bat" "!bat_archiveddir!"
%bat_return%


:CAMSMENU
	call :SAVECONFIG
	echo start CamsMenu.bat>>"!bat_logfile!"
	echo start CamsMenu.bat
	     start CamsMenu.bat
%bat_return%


:POSTMULTISCAN
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!">>"!bat_logfile!"
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!"
	     call PostMultiScanCalibration.bat "!bat_archiveddir!"
%bat_return%


:READCONFIG

	!bat_logexeclog! call "!bat_exedir!\ReadConfig.bat"
!bat_return!


:SAVECONFIG

	!bat_logexeclog! call "!bat_exedir!\SaveConfig.bat"
	
!bat_return!



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
call "!bat_exedir!\Date2JDate.bat"
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat"
EXIT /b 0





:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 Determines the ArchivedFiles directory created by capture operation.
    echo.
	echo.    Command line arguments:
	echo.        bat_CD_flag
	echo.        bat_camera
	echo.        bat_duration
	echo.        bat_targetlocation
	rem echo.        bat_savetargetlocation
    echo.
EXIT /b -99
    
goto :DONE


:DONE
	!bat_echolog! END OF %~nx0  ******  %date% %time%>>"!bat_logfile!"
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
 exit
