  @echo off
setlocal enabledelayedexpansion enableextensions

rem


:CHECKHELP
	set bat_vers=1.0

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_pushecho!
	

	call "!bat_exedir!\GETDATE2.bat" %*


	set bat_returncode=0
goto :MAIN %*



REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================
REM ======================= MAIN ===================================

:MAIN
!bat_pushlog! [GOTO :MAIN %*]

	!bat_log! Calling "dusk.vbs" to get the twilight dusk/dawn and camera on/off info.
	!bat_log! for /f "delims=" ..a in ^('cscript //nologo dusk.vbs !bat_curryyyy! !bat_currmm! !bat_currdd!'^) do ^(
	          for /f "delims=" %%a in  ('cscript //nologo dusk.vbs !bat_curryyyy! !bat_currmm! !bat_currdd!') do (
		!bat_logexeclog! set bat_VBTemp=%%a
	)

	for /f "tokens=1-17 delims=;" %%a in ("!bat_VBTemp!") do (
                
        set bat_onUT=%%a
		set bat_on=%%a
		set bat_duskutc=%%a
		set bat_calcedon=%%a
		
		set bat_dusklocal=%%b
		
		set bat_offset1=%%c
		
		set bat_off=%%d
		set bat_offUT=%%d
		set bat_dawnutc=%%d
		
		set bat_offtime=%%e
		set bat_offLocal=%%e
		
		set bat_offset2=%%f
		
		set bat_duration=%%g
		set bat_dur=%%g
		
		Set /a bat_durtotalsecs=%%h
		
                set bat_UTcurrent=%%i

		set ftp_hhmmssdd=%%j
		
		set bat_delaycalc=%%k
		
		set bat_walltimeron=%%l
		set bat_scheduledstarttime=%%l
		
		set bat_walltimeroff=%%m
		
		set bat_camera_temp=%%n
		
		set bat_lat=%%o
		
		set bat_lon=%%p
		
		set bat_weekday=%%q
	)
	
	
	!bat_pushlog! dusk.vbs calculated the following values:
		!bat_echo!   bat_on:			!bat_on!
		!bat_echo!   bat_onUT:			!bat_onUT!
		!bat_echo!   bat_duskutc:		!bat_duskutc!
		!bat_echo!   bat_calcedon:		!bat_calcedon!
		!bat_echo!
		!bat_echo!   bat_dusklocal:		!bat_dusklocal!
		!bat_echo!
		!bat_echo!   bat_offset1:		!bat_offset1!
		!bat_echo!
		!bat_echo!   bat_off:			!bat_off!
		!bat_echo!   bat_offUT:		!bat_offUT!
		!bat_echo!   bat_dawnutc:		!bat_dawnutc!
		!bat_echo!
		!bat_echo!   bat_offtime:		!bat_offtime!
		!bat_echo!   bat_offLocal:		!bat_offLocal!
		!bat_echo!
		!bat_echo!   bat_offset2:		!bat_offset2!
		!bat_echo!
		!bat_echo!   bat_duration:		!bat_duration!
		!bat_echo!
		!bat_echo!   bat_durtotalsecs:		!bat_durtotalsecs!
		!bat_echo!
		!bat_echo!   bat_UTcurrent:		!bat_UTcurrent!
		!bat_echo!
		!bat_echo!   ftp_hhmmssdd:		!ftp_hhmmssdd!
		!bat_echo!
		!bat_echo!   bat_delaycalc:		!bat_delaycalc!
		!bat_echo!
		!bat_echo!   bat_walltimeron:		!bat_walltimeron!
		!bat_echo!   bat_scheduledstarttime	!bat_scheduledstarttime!
		!bat_echo!
		!bat_echo!   bat_walltimeroff:		!bat_walltimeroff!
		!bat_echo!
		!bat_echo!	bat_camera_temp:		!bat_camera_temp!
		!bat_echo!
		!bat_echo!   bat_lat [North]:		!bat_lat!
		!bat_echo!
		!bat_echo!   bat_lon [West]:		!bat_lon!
		!bat_echo!
		
		call "!bat_exedir!\DayOfWeek.bat" !bat_currdate!
		set bat_weekday=!bat_retval!
		!bat_echo!   bat_weekday:              !bat_weekday!
		!bat_echo!
		!bat_echo!
	!bat_pop!



			echo 	Task Scheduler Start Time (Wall timer ON)=!bat_scheduledstarttime!
			echo.
			echo 	Task Scheduler Stop Time (Wall timer OFF)=!bat_walltimeroff!
			echo.

			echo    Date=               %bat_twilight_searchstr%  - Date of these calculations ^(!bat_weekday!^)
			call :CALCDAYNUMBER %bat_twilight_searchstr%
			echo    Day number=         !bat_day_number!         - Day of the year 
			echo    Task Sched Start    !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time        !ftp_hhmmssdd!    - Current local time
			echo.
			echo    Camera ON=          %bat_dusklocal% (UT%bat_offset1%)   - Local time Task Scheduler should start capture
			echo    Camera ON UTC       %bat_onUT%     - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle !bat_CAPTURE.sunangle_dusk! - degrees below horizon
			echo.
			echo    Camera OFF UTC       %bat_offUT%   - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %bat_offtime% (UT%bat_offset2%)   - Local time capture should end in the morning
			echo    Camera OFF sun angle !bat_CAPTURE.sunangle_dawn! - degrees below horizon
			echo.

			echo    Duration=            %bat_dur%      - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Delay=               %bat_delaycalc%       - Number of seconds to delay from the current time
			echo                                      Note: Dawn is calculated for the next morning
			set /a bat_estCapFiles=!bat_durtotalsecs!0000 / 85333
			set /a bat_estSizeMB=!bat_estCapFiles!*11723 / 10000
			set /a bat_reqdisk=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!*!bat_CAPTURE.number.of.cameras!

			call "str_math.bat" -command "[math]::round(!bat_estSizeMB! / 1024,3)">nul:
			echo    Disk space required per night per camera=!bat_retval! GB
			echo    Disk space warning days=!bat_AUTOCAMS.diskspacewarning.days!
			call "str_math.bat" -command "[math]::round(!bat_reqdisk! / 1024,3)">nul:
			echo    Estimated space requirements for the next !bat_AUTOCAMS.diskspacewarning.days! nights is roughly: !bat_retval! GB
			echo.
			echo    To check how much disk space you will require over the next !bat_AUTOCAMS.diskspacewarning.days! days, 
			echo    execute this command:
			echo        call "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalsecs!
			echo.
			echo        [Note: See the AutoCams.Params.ini file to adjust these warnings:
			echo           diskspacewarning.days=!bat_AUTOCAMS.diskspacewarning.days!
			echo.


!bat_log! exit /b !bat_returncode!
	set bat_VBTemp=
exit /b !bat_returncode!
goto :DONE








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo.  Usage: %~nx0 [yyyy mm dd]
	echo.
	echo.  Calls the dusk.vbs script and reports back on the variables it returns.
	echo.
	echo.  Example:
	echo.    %~nx0 2014 12 13
	echo.
	call 7za.exe -h
exit /b -99



:DONE
	!bat_poplog! Done with %0 %*
	!bat_log!