@echo off
setlocal enableextensions enabledelayedexpansion

    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	if "%~1" equ "" (goto :HELP)

	set bat_date=%~1

	set bat_spacer=                                                  


	echo."Pointing_!bat_date!.txt"
	echo.>"Pointing_!bat_date!.txt"

	echo.                           Height Cam                              Focal Fov    Fov               
	echo.  Lat         Long          WGS84  ID  Azimuth    Elev Color         Len Wt      Ht      Tilt  Scale  Comments                  
	echo.--------- ----------- ----------- --- -------- ------- --------- ------- ---------- --------- ------ -----------------------------------------------

	rem echo.for  /f "usebackq tokens=*" ..a in ^(`dir "cal\cal???_!bat_date!_*.txt" /a-d /b /on`^) do ^(
	for      /f "usebackq tokens=*" %%a in  (`dir "cal\cal???_!bat_date!_*.txt" /a-d /b /on`) do (
		echo.>>"Pointing_!bat_date!.txt"
		echo.%%a>>"Pointing_!bat_date!.txt"
		
		rem echo.%%a
		
		set /a bat_count=0
		rem echo.for /f "useback tokens=1-10 delims==" ..b in ^(`findstr /i /c:"Camera number" /c:"azim" /c:"elev" /c:"calibration date" /c:"calibration time" /c:"fov dimension" /c:"plate scale" /c:"cam tilt" /c:"camera description" /c:"focal length" /c:"focal ratio"   "cal\%%a"`^) do ^(

		rem echo.for  /f "useback tokens=1-2 delims==" ..b in ^(`find /i /v"" "cal\%%a"`^) do ^(
		for      /f "useback tokens=1-2 delims==" %%b in  (`type "cal\%%a"`) do (
			set /a bat_count+=1
			set bat_temp=%%c
			
rem echo.!bat_count!	[!bat_temp!]	[%%b, %%c]
			
			if !bat_count! equ 1 (
				call :FILL_RIGHT "!bat_temp!" 3
				set bat_CameraNumber=!bat_retval!
			)
			
			if !bat_count! equ 2 (
				call :FILL_LEFT "!bat_temp!" 10
				set bat_CalDate=!bat_retval!
			)
			
			if !bat_count! equ 3 (
				call :FILL_LEFT "!bat_temp!" 12
				set bat_CalTime=!bat_retval!
			)
			
			if !bat_count! equ 4 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Long=!bat_retval!
			)
			
			if !bat_count! equ 5 (
				call :FILL_RIGHT "!bat_temp!" 9
				set bat_Lat=!bat_retval!
			)
			
			if !bat_count! equ 6 (
				call :FILL_RIGHT "!bat_temp!" 11
				set bat_Height=!bat_retval!
			)
			
			if !bat_count! equ 7 (
				for /f "tokens=1,2 delims=x" %%k in ("!bat_temp!") do (
					call :FILL_RIGHT "%%k" 5
					set bat_FovH=!bat_retval!
					
					call :FILL_RIGHT "%%l" 5
					set bat_FovW=!bat_retval!
				)
			)
			
			if !bat_count! equ 8 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_Scale=!bat_retval!
			)
			
			if !bat_count! equ 9 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_roll=!bat_retval!
			)
			
			if !bat_count! equ 10 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Tilt=!bat_retval!
			)
			
			if !bat_count! equ 14 (
				call :FILL_RIGHT "!bat_temp!" 8
				set bat_Az=!bat_retval!
			)
			
			if !bat_count! equ 15 (
				call :FILL_RIGHT "!bat_temp!" 7
				set bat_Elev=!bat_retval!
			)
			
			if !bat_count! equ 19 (
				call :STRIP_WHITESPACE "!bat_temp!" 30
				set bat_Descr=!bat_retval!
			)
			
			if !bat_count! equ 21 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalLength=!bat_retval!
			)
			
			if !bat_count! equ 22 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_FocalRatio=!bat_retval!
			)
			
			if !bat_count! equ 23 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchH=!bat_retval! um
			)
			
			if !bat_count! equ 24 (
				call :FILL_RIGHT "!bat_temp!" 6
				set bat_PitchV=!bat_retval!
			)
			
			
		)
		
		set bat_output=!bat_Lat! !bat_Long! !bat_Height! !bat_CameraNumber! !bat_Az! !bat_Elev!            !bat_FocalLength! !bat_FovW! !bat_FovH! !bat_Tilt! !bat_scale! !bat_Descr! !bat_PitchH! x !bat_PitchV! ^(um^)
		echo.!bat_output!
		rem set bat_
		
	)


echo.
echo.
echo.Output is found in: "%CD%\Pointing_!bat_date!.txt"

goto :DONE




:FILL_RIGHT 
	set bat_retval=!bat_spacer!%~1
rem	echo.[[[[set bat_retval=!bat_retval:~-%~2!]]]]]]]]]
	set bat_retval=!bat_retval:~-%~2!
exit /b 0



:FILL_LEFT 
	set bat_retval=%~1!bat_spacer!
	set bat_retval=!bat_retval:~0,%~2!
	
exit /b 0


:STRIP_WHITESPACE 
	set bat_retval=
	
	set bat_retval=%~1

exit /b 0


 	Az	Elev	Color	Lens	fov	Tilt/Roll	Scale	Comments
114	25.2	28.7	00E6B8 cyan	12	30.2 x 22.1	-3	2.8	watec



:HELP
	echo.missing date
	echo.
	echo.Usage: %~0 ^<yyyymmdd^>
	echo.
exit /b 99

:DONE

