  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	rem echo.%*|find /i "/?">nul:
	rem if %errorlevel% equ 0 (goto :HELP)
	rem echo.%*|find /i "/h">nul:
	rem if %errorlevel% equ 0 (goto :HELP)

	(echo.%*|findstr /L /i /c:"/help" >nul: 2>&1) && (goto :HELP)
	
	echo.
goto :SETUP


		
	
	
:SETUP

	call "%~dp0clear_bat_vars.bat"

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "%~dp0ReadParams.bat"


	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

	call "%~dp0ReadConfig.bat"


goto :MAIN %*


:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] [%*]


	set bat_commandline=%*
	
	if /i "%~1" equ "" (set bat_commandline=%*)


	!bat_echolog! 
	!bat_echolog! %~nx0 - Command Line:
	!bat_echolog! %*
	!bat_echolog! Starting command immediately after the following line
	!bat_echolog! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

	              %*
	              set bat_returncode=%errorlevel%
!bat_echolog! ................ TESTSCRIPT ..............
rem echo off
	!bat_echolog!
	!bat_echolog! vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
	!bat_echolog! TestScript has returned from the called script
	!bat_echolog! [ERRORLEVEL=!bat_returncode!]
	!bat_echolog!
	!bat_echolog!

!bat_pause!

rem 	!bat_echolog!

:MAIN_END
!bat_popecho! [RETURN !bat_batchfile!:DONE] [ok]
!bat_echolog!
goto :DONE




:HELP
	echo.Usage: call "%~nx0"
	echo.
	echo.Forwards the command line to test sub-scripts by providing all the extra
	echo.indent and debugging infrastructure.  That way, it can simulate how the
	echo.subscripts are called by autocams.bat and other main scripts.
	echo.
	echo.This is especially useful for those scripts that you want to test, but they
	echo.don't stand alone, such as FTPhash.bat, GetCameraList.bat, ReadParams.bat, etc.
	echo.
	echo.Returns:
	echo.  nothing
	echo.
	echo.Example(s):
	echo.    %~f0 FTPhash test.zip
	echo.
	echo.After it calls the FTPhash script, the environment variables can be 
	echo.compared.
	echo.
exit /b -99








:DONE
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog! [DONE !bat_batchfile!:DONE]
!bat_echolog!
exit /b 0
