  @echo off
setlocal enabledelayedexpansion enableextensions


:CHECKHELP

	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:

	New changes 09/21/2011:
		
	
	
:SETUP
	
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"


	!bat_echolog! =============================================================

	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!


	if /i "!bat_paramsfile!" equ "" (
		set bat_paramsfile=!bat_exedir!\AutoCams.Params.ini
	)

goto :MAIN



:MAIN
	rem check if it's on
	     findstr /B /i "bat_indent_log_debug=false" "!bat_paramsfile!"
	set bat_returncode=!errorlevel!
	echo.findstr /B /i "bat_indent_log_debug=false" "!bat_paramsfile!" [yields !bat_returncode!]
	if !bat_returncode! equ 0 (
		!bat_echolog! Toggling debug ON [!bat_returncode!]
		!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -V --c-style "!bat_paramsfile!" bat_indent_log_debug=false bat_indent_log_debug=true
		set bat_indent_log_debug=true
	) else (
		!bat_echolog! Toggling debug OFF [!bat_returncode!]
		!bat_logexec! call "!bat_exedir!\ReplaceText.exe" -V --c-style "!bat_paramsfile!" bat_indent_log_debug=true bat_indent_log_debug=false
		set bat_indent_log_debug=false
	)

:MAIN_END
	
!bat_popecho! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ENDLOCAL & (
	echo.ENDLOCAL SET bat_indent_log_debug=%bat_indent_log_debug%
	SET bat_indent_log_debug=%bat_indent_log_debug%
)

EXIT /b 0













:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 
	echo.
	echo Toggles the setting 
	echo.
	echo Example 1:
	echo    set bat_archivedfilesdir=c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfile"     "bat_archivedfilesdir"
	echo Results: bat_detectfile=
	echo    "c:\cam213\CAMS\ArchivedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Example 2:
	echo    set bat_confirmedfilesdir=c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39
	echo    %~nx0 "bat_detectfileconf" "bat_confirmedfilesdir"
	echo Results: bat_detectfile=
	echo    c:\cam213\CAMS\ConfirmedFiles\2012_08_11_08_30_39\
	echo    FTPdetectinfo_02160213_2012_08_11_08_30_39.txt"
	echo.
	echo Notice how the environment variable names are passed an not their
	echo values.  
	echo.
exit /b -99



:DONE
!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
