@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP

echo "%~dp0"



	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"
	call "!bat_exedir!\ReadParams.bat"

set bat_pushstring=     

exit /b 1



!bat_prompt!

echo.bat_choice=[!bat_choice!]

if /i "!bat_choice!" equ "q" (
	echo..................QUITTING.............
) else (
	echo..................CONTINUING.............
)

echo.bat_indent_pause=!bat_indent_pause!
echo.bat_choice=!bat_choice!

exit /b -99







	echo.=============================================================
	echo.%~0 [%*]
	set /a bat_count=0

	call :READPARAMS
	call :READCONFIG


	set bat_confirmedfilesdir=!bat_archivedfilesdir:ArchivedFiles=ConfirmedFiles!

	if /i "%~1" neq "" (
		rem The user specified a source directory so don't ask the directory
		set bat_targetdir=
		call :TEST1 %*
	) else (
		rem The user didn't specify a source directory, so ask which of the thre directories to process
	)

	goto :DONE




:TEST1
	echo.[TEST1] [%~1]
	if /i "%~1" equ "" goto :TEST_END
	set /a bat_count+=1

	if /i "%~1" equ "/archiveddir" (
		set bat_archivedfilesdir=%~2
		set bat_targetdir=%~1
		echo.bat_archivedfilesdir="!bat_archivedfilesdir!"
	) else (
			if /i "%~1" equ "/captureddir" (
			set bat_capturedfilesdir=%~2
			set bat_targetdir=%~1
			echo.bat_capturedfilesdir="!bat_capturedfilesdir!"
		) else (
			if /i "%~1" equ "/confirmeddir" (
				set bat_confirmedfilesdir=%~2
				set bat_targetdir=%~1
				echo.bat_confirmedfilesdir="!bat_confirmedfilesdir!"
			) else (
				set bat_returncode=1
				set bat_errormsg=ERROR - invalid command line argument[s] %*
			)
		)
	)

:TEST_END
!bat_return!


exit /b 0



:READCONFIG
!bat_pushlog! [CALL !bat_batchfile!:READCONFIG] %*
	set bat_retval=failed
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	
	!bat_push!
	for /f "usebackq tokens=*" %%x in (`type "!bat_configfile!"`) do (
		set bat_retval=success
		set bat_temp=%%x
							rem if /i "%%x" neq "[CAMSMENU]" (
							rem      set %%x
							rem )

		if /i "!bat_temp!" neq "" (
			if /i "!bat_temp:~0,1!" neq " " (
				if /i "!bat_temp:~0,1!" neq "	" (
					if /i "!bat_temp:~0,2!" neq "//" (
						rem It's not a single-line comment "//"

						if /i "!bat_temp:~0,3!" neq "rem" (
							rem It's not a single line comment "rem"

							if /i "!bat_temp:~0,4!" neq "rem " (
								rem It's not a comment "rem "

								if /i "!bat_temp:~0,1!" equ "[" (
									rem It's a [section]
									set bat_temp=!bat_temp:~1,99!
									set bat_inisection=bat_!bat_temp:~0,-1!
								) else (
									rem It's a bat_key=value
									if "!bat_temp:~0,4!" equ "bat_" (
									rem !bat_log! '    set !bat_temp!
												   set !bat_temp!
									) else (
											rem It's a key=value
											set !bat_inisection!.!bat_temp!
									)
								)
							)
						)
					)
				)
			)
		)
	)
	!bat_pop!

	rem set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdrive=!bat_targetlocation!

:READCONFIG_END
!bat_poplog! [RETURN !bat_batchfile!:READCONFIG] [AutoCams.bat.ini=!bat_retval!, "!bat_capturedfilesdir!"]
!bat_log!
!bat_return!



:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!






:DONE
echo.
!bat_popecho! DONE
echo.
