@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	set bat_return=goto :EOF
	@echo.
	@echo %0
	echo.
	echo %date% %time%
goto :MAIN

:MAIN
	call :PARSECURTIME
	call :PARSEDELAY
	call :ADDCURPLUSDELAY
	CALL :WAITDELAY
!bat_return!

:PARSECURTIME
	set bat_curtime=%time%
	set bat_curh=!bat_curtime:~0,2!
	set bat_curm=!bat_curtime:~3,2!
	set bat_curs=!bat_curtime:~6,2!
!bat_return!

:PARSEDELAY
	set /a bat_delay=%1
	set /a bat_h=!bat_delay!/3600
	set /a bat_r=!bat_delay!-(!bat_h!*3600)
	set /a bat_m=!bat_r!/60
	set /a bat_s=!bat_r!-(!bat_m!*60)
!bat_return!

:ADDCURPLUSDELAY
	set /a bat_remainder=0

	set /a bat_news=!bat_curs!+!bat_s!
	if !bat_news! gtr 59 (
		set /a bat_news=!bat_news!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	set /a bat_newm=!bat_curm!+!bat_carry!+!bat_m!
	if !bat_newm! gtr 59 (
		set /a bat_newm=!bat_newm!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	set /a bat_newh=!bat_curh!+!bat_carry!+!bat_h!
	if !bat_newh! gtr 23 (
		set /a bat_newh=!bat_newh!-24
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :PADZERO bat_h
	call :PADZERO bat_m
	call :PADZERO bat_s
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news

	echo    !bat_curh!:!bat_curm!:!bat_curs!
	echo +  !bat_h!:!bat_m!:!bat_s!
	echo -----------------
	echo    !bat_newh!:!bat_newm!:!bat_news! LT  ^<---- Waiting until
!BAT_RETURN!

:WAITDELAY
	echo start /w wait !bat_delay!
	     start /w wait !bat_delay!
	rem      start /w wait 5
	echo %date% %time%
goto :DONE

:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF


:DONE

