 @echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"
	!bat_logexeclog! set bat_sunsettable=!bat_sunsettablename!

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! Twilight file: "Steve Script 1.0"
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	call "!bat_exedir!\GETDATE2.bat"
	!bat_logexeclog! set bat_curdate=!bat_currdate!&	rem set bat_curdate=%date:~-10%

%bat_COMMENT_BEGIN%
	Rem Parse the date using "/" as delimiters
	echo.%bat_curdate%|find /i "/">nul:
	if %errorlevel% equ 0 (
		Rem echo for /f "delims=/ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=/ tokens=1-3" %%a in ("!bat_curdate!") do (
			Rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	) else (
		Rem Parse the date using "_" as delimiters
		Rem echo for /f "delims=_ tokens=1-3" %%a in ^("!bat_curdate!"^) do ,,,
		for /f "delims=_ tokens=1-3" %%a in ("!bat_curdate!") do (
			Rem echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	)
%bat_COMMENT_END%

:SETUP2	
	set bat_date=!bat_curryyyy!_!bat_currmm!_!bat_currdd!

        set ddSteve=!bat_currdd!
        set mmSteve=!bat_currmm!
        set yyyySteve=!bat_curryyyy!
        set bat_formatdate=!bat_LOCALIZE.format.date!
         if /i "!bat_formatdate:~0,2!" == "dd" (set hulpSteve=%ddSteve%)
         if /i "!bat_formatdate:~0,2!" == "mm" (set hulpSteve=%mmSteve%)
         if /i "!bat_formatdate:~0,4!" == "yyyy" (set hulpSteve=%yyyySteve%)
         if /i "!bat_formatdate:~3,2!" == "dd" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%ddSteve%)
         if /i "!bat_formatdate:~3,2!" == "mm" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%mmSteve%)
         if /i "!bat_formatdate:~3,4!" == "yyyy" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%yyyySteve%)
         if /i "!bat_formatdate:~6,2!" == "dd" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%ddSteve%)
         if /i "!bat_formatdate:~6,2!" == "mm" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%mmSteve%)
         if /i "!bat_formatdate:~6,4!" == "yyyy" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%yyyySteve%)
         if /i "!bat_formatdate:~5,2!" == "dd" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%ddSteve%)
         if /i "!bat_formatdate:~5,2!" == "mm" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%mmSteve%)
         if /i "!bat_formatdate:~5,4!" == "yyyy" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%yyyySteve%)
         if /i "!bat_formatdate:~8,2!" == "dd" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%ddSteve%)
         if /i "!bat_formatdate:~8,2!" == "mm" (set hulpSteve=%hulpsteve%!bat_LOCALIZE.delimiter.date!%mmSteve%)


	set bat_curdate=!hulpSteve!

	Rem set bat_curm=!bat_curdate:~-2!
	Rem set bat_curd=!bat_curdate:~-2!
	Rem set bat_cury=!bat_cury:~-4!
	Rem set bat_cury=!bat_cury:~-4!
	set /a bat_prevy=!bat_curryyyy!-1
	
	Rem set bat_sunsettable=%~dp0twilight.csv.txt
	
:DAYOFWEEK
	call "!bat_exedir!\date2jdate.bat" bat_JD !bat_curryyyy! !bat_currmm! !bat_currdd!
	call "!bat_exedir!\jdate2date.bat" !bat_JD! bat_yyyy bat_mm bat_dd

	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		!bat_logexeclog! set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			!bat_logexeclog! set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				!bat_logexeclog! set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					!bat_logexeclog! set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						!bat_logexeclog! set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							!bat_logexeclog! set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								!bat_logexeclog! set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)

	Rem echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!

        
        set delimiter=!bat_LOCALIZE.delimiter.csv!
        set decimalseparator=!bat_LOCALIZE.separator.decimal!


       



	echo %~0 %*
	echo.
	echo Usage: %~0 mm/dd/yyyy   - Checking script for !bat_curdate!
	echo.
goto :MAIN

:MAIN
       
       set bat_twilight_searchstr=%~1

       if /i ""== "!bat_twilight_searchstr!" (
		set bat_twilight_searchstr=%date%
	)


set ftp_wmdy=!bat_twilight_searchstr!
        set bat_formatdate=!bat_LOCALIZE.format.date!

if /i "!bat_formatdate:~2,1!" equ "/" (
		if /i "!ftp_wmdy:~2,1%!" NEQ "/" (
                 set ftp_wmdy=0!ftp_wmdy!
        ) 
	)

if /i "!bat_formatdate:~5,1!" equ "/" (
		if /i "!ftp_wmdy:~5,1!" NEQ "/" (
                  set ftp_wmdy=!ftp_wmdy:~0,3!0!ftp_wmdy:~3,6!
        )   
	)


         if /i "!bat_formatdate:~0,2!" == "dd" (set ftp_da=!ftp_wmdy:~0,2!)
         if /i "!bat_formatdate:~0,2!" == "mm" (set ftp_mo=!ftp_wmdy:~0,2!)
         if /i "!bat_formatdate:~0,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~0,4!)
         if /i "!bat_formatdate:~3,2!" == "dd" (set ftp_da=!ftp_wmdy:~3,2!)
         if /i "!bat_formatdate:~3,2!" == "mm" (set ftp_mo=!ftp_wmdy:~3,2!)
         if /i "!bat_formatdate:~3,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~3,4!)
         if /i "!bat_formatdate:~6,2!" == "dd" (set ftp_da=!ftp_wmdy:~6,2!)
         if /i "!bat_formatdate:~6,2!" == "mm" (set ftp_mo=!ftp_wmdy:~6,2!)
         if /i "!bat_formatdate:~6,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~6,4!)
         if /i "!bat_formatdate:~5,2!" == "dd" (set ftp_da=!ftp_wmdy:~5,2!)
         if /i "!bat_formatdate:~5,2!" == "mm" (set ftp_mo=!ftp_wmdy:~5,2!)
         if /i "!bat_formatdate:~5,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~5,4!)
         if /i "!bat_formatdate:~8,2!" == "dd" (set ftp_da=!ftp_wmdy:~8,2!)
         if /i "!bat_formatdate:~8,2!" == "mm" (set ftp_mo=!ftp_wmdy:~8,2!)


for /f "delims=" %%Z in ('cscript //nologo dusk.vbs %ftp_year% %ftp_mo% %ftp_da%') do (
	Set BVBTemp=%%Z
)

for /f "tokens=1,2,3,4,5,6,7,8,9,10,11,12 delims=;" %%G in ("%BVBTemp%") do (

  set bat_onUT=%%G
  set bat_dusklocal=%%H
  set bat_offset1=%%I
  set bat_offUT=%%J
  set bat_offtime=%%K
  set bat_offset2=%%L
  set bat_dur=%%M
  Set /a bat_durtotalsecs = %%N
  set ftp_hhmmssdd=%%O
  set bat_delaycalc=%%P
  set bat_scheduledstarttime=%%Q
  set bat_walltimeroff=%%R 
  
)


	echo 	Task Scheduler Start Time (Wall timer ON)=!bat_scheduledstarttime!
	echo.
	echo 	Task Scheduler Stop Time (Wall timer OFF)=!bat_walltimeroff!
	echo.

			echo    Date=               %bat_twilight_searchstr%  - Date of these calculations ^(!bat_weekday!^)
			call :CALCDAYNUMBER %bat_twilight_searchstr%
			echo    Day number=         !bat_res3!         - Day of the year 
			echo    Task Sched Start    !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time        !ftp_hhmmssdd!    - Current local time
			echo.
			echo    Camera ON=          %bat_dusklocal% (UT%bat_offset1%)   - Local time Task Scheduler should start capture
			echo    Camera ON UTC       %bat_onUT%     - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle !bat_CAPTURE.sunangle_dusk! - degrees below horizon
			echo.
			echo    Camera OFF UTC       %bat_offUT%   - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %bat_offtime% (UT%bat_offset2%)   - Local time capture should end in the morning
			echo    Camera OFF sun angle !bat_CAPTURE.sunangle_dawn! - degrees below horizon
			echo.

			echo    Duration=            %bat_dur%      - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Delay=               %bat_delaycalc%       - Number of seconds to delay from the current time
			echo                                      Note: Dawn is calculated for the next morning
			set /a bat_estCapFiles=!bat_durtotalsecs!0000 / 85333
			set /a bat_estSizeMB=!bat_estCapFiles!*11723 / 10000
			set /a bat_reqdisk=!bat_estSizeMB!*!bat_AUTOCAMS.diskspacewarning.days!*!bat_CAPTURE.number.of.cameras!

			call "str_math.bat" -command "[math]::round(!bat_estSizeMB! / 1024,3)">nul:
			echo    Disk space required per night per camera=!bat_retval! GB
			echo    Disk space warning days=!bat_AUTOCAMS.diskspacewarning.days!
			call "str_math.bat" -command "[math]::round(!bat_reqdisk! / 1024,3)">nul:
			echo    Estimated space requirements for the next !bat_AUTOCAMS.diskspacewarning.days! nights is roughly: !bat_retval! GB
			echo.
			echo    To check how much disk space you will require over the next !bat_AUTOCAMS.diskspacewarning.days! days, 
			echo    execute this command:
			echo        call "!bat_exedir!\checkfreespace.bat" !bat_exedrive! !bat_durtotalsecs!
			echo.
			echo        [Note: See the AutoCams.Params.ini file to adjust these warnings:
			echo           [AUTOCAMS]
			echo           diskspacewarning.days=!bat_AUTOCAMS.diskspacewarning.days!
			echo.
		)
	)


set ftp_wmdy=!bat_twilight_searchstr!
        set bat_formatdate=!bat_LOCALIZE.format.date!

if /i "!bat_formatdate:~2,1!" equ "/" (
		if /i "!ftp_wmdy:~2,1%!" NEQ "/" (
                 set ftp_wmdy=0!ftp_wmdy!
        ) 
	)

if /i "!bat_formatdate:~5,1!" equ "/" (
		if /i "!ftp_wmdy:~5,1!" NEQ "/" (
                  set ftp_wmdy=!ftp_wmdy:~0,3!0!ftp_wmdy:~3,6!
        )   
	)


         if /i "!bat_formatdate:~0,2!" == "dd" (set ftp_da=!ftp_wmdy:~0,2!)
         if /i "!bat_formatdate:~0,2!" == "mm" (set ftp_mo=!ftp_wmdy:~0,2!)
         if /i "!bat_formatdate:~0,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~0,4!)
         if /i "!bat_formatdate:~3,2!" == "dd" (set ftp_da=!ftp_wmdy:~3,2!)
         if /i "!bat_formatdate:~3,2!" == "mm" (set ftp_mo=!ftp_wmdy:~3,2!)
         if /i "!bat_formatdate:~3,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~3,4!)
         if /i "!bat_formatdate:~6,2!" == "dd" (set ftp_da=!ftp_wmdy:~6,2!)
         if /i "!bat_formatdate:~6,2!" == "mm" (set ftp_mo=!ftp_wmdy:~6,2!)
         if /i "!bat_formatdate:~6,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~6,4!)
         if /i "!bat_formatdate:~5,2!" == "dd" (set ftp_da=!ftp_wmdy:~5,2!)
         if /i "!bat_formatdate:~5,2!" == "mm" (set ftp_mo=!ftp_wmdy:~5,2!)
         if /i "!bat_formatdate:~5,4!" == "yyyy" (set ftp_year=!ftp_wmdy:~5,4!)
         if /i "!bat_formatdate:~8,2!" == "dd" (set ftp_da=!ftp_wmdy:~8,2!)
         if /i "!bat_formatdate:~8,2!" == "mm" (set ftp_mo=!ftp_wmdy:~8,2!)



goto :DONE

:CALCDAYNUMBER
	Rem Usage: call :CALCDAYNUMBER day
	Rem   where day is the day number from the sunsettable.txt file.  In that file,
	Rem   the day number in in the file for the first date (01/01/2011) has a value
	Rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	Rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	Rem   The only thing that should be an issue between different people using this
	Rem   is the bat_offset number below (109600), which may need to be adjusted 
	Rem   depending how how many days of offset from a daylight savings date
	Rem   is used as the base date.  
	Rem
	Rem   The 109600 number is essentially 1096.00, which represents 3 years
	Rem   before. This algorithm is based on knowning that the 1st day of the 
	Rem   year 3 years before is a known day of the week.
	
	set /a bat_day=%1*100
	set /a bat_offset=109600
	set /a bat_year=36525
	
	set /a bat_divide=(((!bat_day!+!bat_offset!)*10000)/!bat_year!)
	set /a bat_int=((!bat_day!+!bat_offset!)/36525)
	set /a bat_mod=!bat_divide!-(!bat_int!*10000)
	set /a bat_res1=!bat_mod!*36525
	set /a bat_res2=!bat_res1!+100000
	set /a bat_res3=(!bat_res2!/1000000)+1
	set bat_res3=!bat_res3!   
	set bat_res3=!bat_res3:~0,3!
goto :EOF

:ERR1
	echo.
	echo ERROR - Date not found: "!bat_currmm!/!bat_currdd!/!bat_curryyyy!" in "!bat_sunsettablename!"
	echo.
goto :DONE

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	Rem     -- in_val1    [in]  - zero leading number
	Rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b




:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	Rem                        -- JD   [out] - julian days
	Rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	Rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	Rem                        -- DD   [in]  - gregorian day, i.e. 31
	call "!bat_exedir!\Date2JDate.bat" %1 %2 %3 %4
EXIT /b 0




:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	Rem                     -- JD   [in]  - julian days
	Rem                     -- YYYY [out] - gregorian year, i.e. 2006
	Rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	Rem                      -- DD   [out] - gregorian day, i.e. 31
	call "!bat_exedir!\JDate2Date.bat" %1 %2 %3 %4
EXIT /b 0




:HELP
	echo %~nx0
	echo.
	echo  Usage: %~nx0 [date]
	echo.
	echo  Where:
	echo.
	echo   date		Is optional.  If you use the date argugment, it must be
	echo       		in the format of the US dates (yyyy/mm/dd).  If you omit
	echo       		the date argument, it assumes the current date from the 
	echo       		computer's %%date%% environment variable. 
	echo.
	echo  Examples:
	echo.
	echo   CheckTwilight
	echo      Will produce the report for the current date.
	echo.
	echo   CheckTwilight 12/31/2011
	echo      Will produce the report for December 31, 2011
	echo.
	echo  This script presents a report on the dusk/dawn information based on
	echo  the "twilight.csv.txt".  
	echo.
	echo  The "twilight.csv.txt" file should be customized for each site or 
	echo  area. Complete instructions can be found in the Cams.PDF documentation. 
	echo  In general, the file is customized using the the following steps:
	echo    1^) Use Microsoft Excel 2007 or 2010 for the "twilight.xlsm" file
	echo    2^) Edit the fields in yellow to match the values for your station
	echo    3^) File ^> Save As...
	echo    4^) Select "CSV ^(Comma delimted^) ^(*.csv^)"
	echo    5^) Name the file as "twilight.csv"
	echo    6^) Close Excel
	echo    7^) In the AutoCams.Params.ini file [CAPTURE] section, set the 
	echo        bat_sunsettablename= value to the name of the output CSV file. 
	echo    8^) Rename the output file "twilight.csv" to "twilight.csv.txt"
	echo    9^) Run CheckTwilight.bat and look for errors in the report
	echo.
	echo  The script displays the entry that contains the specified
	echo  date in table form.  Then it provides an intepreted report
	echo  in list form.  
exit /b

	
:DONE