
@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP

	(echo.%*|findstr /L /i /c:"/help" /c:"/h" /c:"/?" >nul: 2>&1) && (goto :HELP)

:CHECKHELP_END
goto :SETUP %*

:SETUP
	if "%~1" equ "" goto :HELP

	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] - Version: !bat_vers! - %~dpnx0 %*
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!

		rem Get the bat_capturedfilesdir value
	call "!bat_exedir!\ReadConfig.bat"

	
	set bat_targetdate=%~1
	
	set bat_targetdate=!bat_targetdate:_=!
	
	echo.!bat_pushstring!bat_targetdate=!bat_t
	
	
	set bat_caldir=!bat_targetlocation!\CAMS\Cal
	
	
goto :MAIN %*


:MAIN
!bat_pushlog! [GOTO !bat_batchfile!:MAIN] %*

	set bat_returncode=0
	
	rem !bat_echolog! for  ..a in ^(`"!bat_caldir!\CAL???_!bat_targetdate!_*.txt" /on /a-d`^) do ^(
	echo.!bat_pushstring!Cal File                   	Date               	Size
	echo.!bat_pushstring!---------------------------	-------------------	-------
	for                %%a in  ("!bat_caldir!\CAL???_!bat_targetdate!_*.txt") do (
		(echo.%dpa|findstr /L /i /c:"/BinFiles" >nul: 2>&1)
		if !errorlevel! equ 0 (rem) else (
			echo.!bat_pushstring!%%~nxa	%%~ta	%%~za
		)
	)


:MAIN_END
!bat_poplog! [END-!bat_batchfile!:MAIN] - goto :DONE
goto :DONE













:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<yyyymmdd^>
	echo.
	echo.    Where yyyymmdd is a date compatible with cal file dates.
	echo.
	echo     Example: 
	echo        %~0 "2011_10_21"
	echo.
	echo     Outputs a list of cal files for the given date, ordered by
	echo     camera, then date.  
	echo.
exit /b



:DONE
	!bat_poplog! [goto !bat_batchfile!:DONE] [bat_returncode=!bat_returncode!]
	!bat_log! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_log! exit /b !bat_returncode!
	          exit /b !bat_returncode!
